Edit

Share via


Items - Create Mirrored Database

Creates a mirrored database in the specified workspace.
This API does not support creating a mirrored database without a definition. To create Mirrored database with definition, refer to Mirrored database definition article.

Permissions

The caller must have a contributor workspace role.

Required Delegated Scopes

MirroredDatabase.ReadWrite.All or Item.ReadWrite.All

Microsoft Entra supported identities

This API supports the Microsoft identities listed in this section.

Identity Support
User Yes
Service principal and Managed identities Yes

Interface

POST https://api.fabric.microsoft.com/v1/workspaces/{workspaceId}/mirroredDatabases

URI Parameters

Name In Required Type Description
workspaceId
path True

string (uuid)

The workspace ID.

Request Body

Name Required Type Description
definition True

MirroredDatabaseDefinition

The mirrored database public definition.

displayName True

string

The mirrored database display name. The display name must follow naming rules according to item type.

description

string

The mirrored database description. Maximum length is 256 characters.

folderId

string (uuid)

The folder ID. If not specified or null, the mirrored database is created with the workspace as its folder.

sensitivityLabelSettings

SensitivityLabelSettings

The sensitivity label settings for the mirrored database.

Responses

Name Type Description
201 Created

MirroredDatabase

Successfully created

429 Too Many Requests

ErrorResponse

The service rate limit was exceeded. The server returns a Retry-After header indicating, in seconds, how long the client must wait before sending additional requests.

Headers

Retry-After: integer

Other Status Codes

ErrorResponse

Common error codes:

  • InvalidItemType - Item type is invalid

  • ItemDisplayNameAlreadyInUse - Item display name is already used.

  • CorruptedPayload - The provided payload is corrupted.

  • WorkspaceItemsLimitExceeded - Workspace item limit exceeded.

Examples

Create a mirrored database with public definition example

Sample request

POST https://api.fabric.microsoft.com/v1/workspaces/a0a0a0a0-bbbb-cccc-dddd-e1e1e1e1e1e1/mirroredDatabases

{
  "displayName": "Mirrored database 1",
  "description": "A mirrored database description",
  "definition": {
    "parts": [
      {
        "path": "mirroring.json",
        "payload": "eyAicHJvcGVydGllcy..WJsZSIgfSB9IH0gXSB9IH0",
        "payloadType": "InlineBase64"
      }
    ]
  }
}

Sample response

{
  "displayName": "Mirrored database 1",
  "description": "A mirrored database description",
  "type": "MirroredDatabase",
  "workspaceId": "a0a0a0a0-bbbb-cccc-dddd-e1e1e1e1e1e1",
  "id": "b1b1b1b1-cccc-dddd-eeee-f2f2f2f2f2f2",
  "sensitivityLabel": {
    "id": "b7b4f4d9-3f0d-4b3e-8f3d-4f6d3f4f3f4f"
  }
}

Definitions

Name Description
CreateMirroredDatabaseRequest

Create mirrored database request payload.

EntireTenantPrincipal

Represents a tenant principal

ErrorRelatedResource

The error related resource details object.

ErrorResponse

The error response.

ErrorResponseDetails

The error response details.

GroupDetails

Group specific details. Applicable when the principal type is Group.

GroupPrincipal

Represents a security group.

GroupType

The type of the group. Additional group types may be added over time.

ItemTag

Represents a tag applied on an item.

ItemType

The type of the item. Additional item types may be added over time.

MirroredDatabase

A mirrored database item.

MirroredDatabaseDefinition

Mirrored database public definition object. Refer to this article for more details on the structure of the Mirrored database definition.

MirroredDatabaseDefinitionPart

Mirrored database definition part object.

MirroredDatabaseProperties

The mirrored database properties.

PayloadType

The type of the definition part payload. Additional payload types may be added over time.

PrincipalType

The type of the principal. Additional principal types may be added over time.

SensitivityLabel

Represents a sensitivity label applied to an item.

SensitivityLabelApplyStrategy

The strategy for applying the sensitivity label. The default value is ApplyOrFail. Additional types may be added over time.

SensitivityLabelSettings

The sensitivity label settings.

ServicePrincipalDetails

Service principal specific details. Applicable when the principal type is ServicePrincipal.

ServicePrincipalPrincipal

Represents a Microsoft Entra service principal.

ServicePrincipalProfileDetails

Service principal profile details. Applicable when the principal type is ServicePrincipalProfile.

ServicePrincipalProfilePrincipal

Represents a service principal profile.

SqlEndpointProperties

An object containing the properties of the SQL endpoint.

SqlEndpointProvisioningStatus

The SQL endpoint provisioning status type. Additional SqlEndpointProvisioningStatus types may be added over time.

UserDetails

User principal specific details. Applicable when the principal type is User.

UserPrincipal

Represents a Microsoft Entra user principal.

CreateMirroredDatabaseRequest

Create mirrored database request payload.

Name Type Description
definition

MirroredDatabaseDefinition

The mirrored database public definition.

description

string

The mirrored database description. Maximum length is 256 characters.

displayName

string

The mirrored database display name. The display name must follow naming rules according to item type.

folderId

string (uuid)

The folder ID. If not specified or null, the mirrored database is created with the workspace as its folder.

sensitivityLabelSettings

SensitivityLabelSettings

The sensitivity label settings for the mirrored database.

EntireTenantPrincipal

Represents a tenant principal

Name Type Description
displayName

string

The principal's display name.

id

string (uuid)

The principal's ID.

type string:

EntireTenant

The type of the principal. Additional principal types may be added over time.

ErrorRelatedResource

The error related resource details object.

Name Type Description
resourceId

string

The resource ID that's involved in the error.

resourceType

string

The type of the resource that's involved in the error.

ErrorResponse

The error response.

Name Type Description
errorCode

string

A specific identifier that provides information about an error condition, allowing for standardized communication between our service and its users.

message

string

A human readable representation of the error.

moreDetails

ErrorResponseDetails[]

List of additional error details.

relatedResource

ErrorRelatedResource

The error related resource details.

requestId

string (uuid)

ID of the request associated with the error.

ErrorResponseDetails

The error response details.

Name Type Description
errorCode

string

A specific identifier that provides information about an error condition, allowing for standardized communication between our service and its users.

message

string

A human readable representation of the error.

relatedResource

ErrorRelatedResource

The error related resource details.

GroupDetails

Group specific details. Applicable when the principal type is Group.

Name Type Description
groupType

GroupType

The type of the group. Additional group types may be added over time.

GroupPrincipal

Represents a security group.

Name Type Description
displayName

string

The principal's display name.

groupDetails

GroupDetails

Group specific details. Applicable when the principal type is Group.

id

string (uuid)

The principal's ID.

type string:

Group

The type of the principal. Additional principal types may be added over time.

GroupType

The type of the group. Additional group types may be added over time.

Value Description
Unknown

Principal group type is unknown.

SecurityGroup

Principal is a security group.

DistributionList

Principal is a distribution list.

ItemTag

Represents a tag applied on an item.

Name Type Description
displayName

string

The name of the tag.

id

string (uuid)

The tag ID.

ItemType

The type of the item. Additional item types may be added over time.

Value Description
Dashboard

PowerBI dashboard.

Report

PowerBI report.

SemanticModel

PowerBI semantic model.

PaginatedReport

PowerBI paginated report.

Datamart

PowerBI datamart.

Lakehouse

A lakehouse.

Eventhouse

An eventhouse.

Environment

An environment.

KQLDatabase

A KQL database.

KQLQueryset

A KQL queryset.

KQLDashboard

A KQL dashboard.

DataPipeline

A data pipeline.

Notebook

A notebook.

SparkJobDefinition

A spark job definition.

MLExperiment

A machine learning experiment.

MLModel

A machine learning model.

Warehouse

A warehouse.

Eventstream

An eventstream.

SQLEndpoint

An SQL endpoint.

MirroredWarehouse

A mirrored warehouse.

MirroredDatabase

A mirrored database.

Reflex

A Reflex.

GraphQLApi

An API for GraphQL item.

MountedDataFactory

A MountedDataFactory.

SQLDatabase

A SQLDatabase.

CopyJob

A Copy job.

VariableLibrary

A VariableLibrary.

Dataflow

A Dataflow.

ApacheAirflowJob

An ApacheAirflowJob.

WarehouseSnapshot

A Warehouse snapshot.

DigitalTwinBuilder

A DigitalTwinBuilder.

DigitalTwinBuilderFlow

A Digital Twin Builder Flow.

MirroredAzureDatabricksCatalog

A mirrored azure databricks catalog.

Map

A Map.

AnomalyDetector

An Anomaly Detector.

UserDataFunction

A User Data Function.

GraphModel

A GraphModel.

GraphQuerySet

A Graph QuerySet.

SnowflakeDatabase

A Snowflake Database to store Iceberg tables created from Snowflake account.

OperationsAgent

A OperationsAgent.

CosmosDBDatabase

A Cosmos DB Database.

Ontology

An Ontology.

EventSchemaSet

An EventSchemaSet.

DataAgent

A DataAgent.

MirroredDatabase

A mirrored database item.

Name Type Description
defaultIdentity Principal:

The item's default identity.

description

string

The item description.

displayName

string

The item display name.

folderId

string (uuid)

The folder ID.

id

string (uuid)

The item ID.

properties

MirroredDatabaseProperties

The mirrored database properties.

sensitivityLabel

SensitivityLabel

The item sensitivity label.

tags

ItemTag[]

List of applied tags.

type

ItemType

The item type.

workspaceId

string (uuid)

The workspace ID.

MirroredDatabaseDefinition

Mirrored database public definition object. Refer to this article for more details on the structure of the Mirrored database definition.

Name Type Description
parts

MirroredDatabaseDefinitionPart[]

A list of definition parts.

MirroredDatabaseDefinitionPart

Mirrored database definition part object.

Name Type Description
path

string

The mirrored database part path.

payload

string

The mirrored database part payload.

payloadType

PayloadType

The payload type.

MirroredDatabaseProperties

The mirrored database properties.

Name Type Description
defaultSchema

string

Default schema of the mirrored database. This property is returned only for mirrored database that enables default schema in definition.

oneLakeTablesPath

string

OneLake path to the mirrored database tables directory.

sqlEndpointProperties

SqlEndpointProperties

An object containing the properties of the SQL endpoint.

PayloadType

The type of the definition part payload. Additional payload types may be added over time.

Value Description
InlineBase64

Inline Base 64.

PrincipalType

The type of the principal. Additional principal types may be added over time.

Value Description
User

Principal is a Microsoft Entra user principal.

ServicePrincipal

Principal is a Microsoft Entra service principal.

Group

Principal is a security group.

ServicePrincipalProfile

Principal is a service principal profile.

EntireTenant

Principal represents all tenant users.

SensitivityLabel

Represents a sensitivity label applied to an item.

Name Type Description
id

string (uuid)

The sensitivity label ID.

SensitivityLabelApplyStrategy

The strategy for applying the sensitivity label. The default value is ApplyOrFail. Additional types may be added over time.

Value Description
ApplyOrFail

Apply the sensitivity label or fail the operation if it cannot be applied.

Ignore

Ignore the sensitivity label if it cannot be applied and proceed with the operation without applying the label.

SensitivityLabelSettings

The sensitivity label settings.

Name Type Description
labelId

string (uuid)

The sensitivity label ID.

sensitivityLabelApplyStrategy

SensitivityLabelApplyStrategy

The strategy for applying the sensitivity label.

ServicePrincipalDetails

Service principal specific details. Applicable when the principal type is ServicePrincipal.

Name Type Description
aadAppId

string (uuid)

The service principal's Microsoft Entra AppId.

ServicePrincipalPrincipal

Represents a Microsoft Entra service principal.

Name Type Description
displayName

string

The principal's display name.

id

string (uuid)

The principal's ID.

servicePrincipalDetails

ServicePrincipalDetails

Service principal specific details. Applicable when the principal type is ServicePrincipal.

type string:

ServicePrincipal

The type of the principal. Additional principal types may be added over time.

ServicePrincipalProfileDetails

Service principal profile details. Applicable when the principal type is ServicePrincipalProfile.

Name Type Description
parentPrincipal Principal:

The service principal profile's parent principal.

ServicePrincipalProfilePrincipal

Represents a service principal profile.

Name Type Description
displayName

string

The principal's display name.

id

string (uuid)

The principal's ID.

servicePrincipalProfileDetails

ServicePrincipalProfileDetails

Service principal profile details. Applicable when the principal type is ServicePrincipalProfile.

type string:

ServicePrincipalProfile

The type of the principal. Additional principal types may be added over time.

SqlEndpointProperties

An object containing the properties of the SQL endpoint.

Name Type Description
connectionString

string

SQL endpoint connection string.

id

string

SQL endpoint ID.

provisioningStatus

SqlEndpointProvisioningStatus

The SQL endpoint provisioning status.

SqlEndpointProvisioningStatus

The SQL endpoint provisioning status type. Additional SqlEndpointProvisioningStatus types may be added over time.

Value Description
InProgress

SQL endpoint provisioning is in progress.

Success

SQL endpoint provisioning succeeded.

Failed

SQL endpoint provisioning failed.

UserDetails

User principal specific details. Applicable when the principal type is User.

Name Type Description
userPrincipalName

string

The user principal name.

UserPrincipal

Represents a Microsoft Entra user principal.

Name Type Description
displayName

string

The principal's display name.

id

string (uuid)

The principal's ID.

type string:

User

The type of the principal. Additional principal types may be added over time.

userDetails

UserDetails

User principal specific details. Applicable when the principal type is User.